var BreakException = {}; 		//< variable to catch expections
var Max_iterrarions = 100000; 	//< how many iteration program could doing before print error

var registers = []; //< main register

//-----------------------------------------------------------------------------
// Array with RAM code information
//-----------------------------------------------------------------------------
var breakpoints = [];
var labels = [];  	//< Lists of labels - etykiety
var commands = [];  //< Lists of commends 
var operands = [];	//< Lists of opperands
var addresses = [];	//< Lists of addresses
var comments = [];	//< Lists of comments

//-----------------------------------------------------------------------------
// Counters
//-----------------------------------------------------------------------------
var instruction_counter = 0;   //< Counter of instructions
var actual_instruction = 0;   //< actual runing instruction

//-----------------------------------------------------------------------------
// Input/outpu tape
//-----------------------------------------------------------------------------
var input_size = 0; //< Input size
var input_head = 0;	//< Głowica wejściowa
var output_head = 0; //< Głowica wyjsciowa

//< Array stored number values of the tape in
var we_cell_memory = new Array(0, null, null, null, null, null);

//< Array stored number values of the tape out
var wy_cell_memory = new Array(null, null, null, null, null, null);

var min_value_in = 1; ///min number of tape in
var max_value_in = 6; ///max number of tape in
var min_value_out = 1; ///min number of tape out
var max_value_out = 6; ///max number of tape out

//-----------------------------------------------------------------------------
// Statistic
//-----------------------------------------------------------------------------
var iterations_counter = 0; 
var command_list = [0,0,0,0,0,0,0,0,0,0,0,0]; // counter of command list :: {LOAD, STORE, ADD, SUB, MULT, DIV, READ, WRITE, JUMP, JZERO, JGTZ, HALT}
var logaritm_time_cost = 0; // auxiliary variable to sum all time costs
var high_val_reg = 0; // variable to storage the higest value in register
var tab_value_max = [];					// array storage information about max value in registers - normal mode

//-----------------------------------------------------------------------------
// Chart
//-----------------------------------------------------------------------------
var calc_cost_registers = [];			//< main register for creating charts
var calc_cost_actual_instruction = 0;   //< actual runing instruction
var calc_cost_iterations_counter = 0;	//< Counter of executed instructions - using to calculate time cost

var calc_cost_command_list = 0; 		// counter of command list
var calc_cost_logaritm_time_cost = 0;   // auxiliary variable to sum all time costs
var calc_cost_high_val_reg = 0; 		// variable to storage the higest value in register
var calc_cost_tab_value_max = [];		// array storage information about max value in registers - for all  value in tape - chart mode

var calc_cost_input_size = 0;			// tape in size

var actual_read_input;					// actual read input tape cell 
var generate_numbers = [[1], [2], [3], [4], [5]];	// array to storage value to generate chart O(...)

// Array to storage program cost for all values in tape input
var all_time_cost = [];
var all_log_time_cost = []; 
var all_mem_cost = [];
var all_log_mem_cost = []; 

var function_value = []; // Array storage output value from functions O(...) - this array using to generate chart
var chart_cont_cost_data = []; // Array storage output value from program calculate cost - this array using to generate chart
var x_axis_label = [1,2,3,4,5]; // values display below x axis

// Texts that describes the charts
var function_title = "";
var calc_cost_title = "";

// Const array with values using to filling the input tape
const natural_numbers = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20];
const prime_numbers = [2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71];
const composite_numbers = [4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32];
const constant_1 = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];


//-----------------------------------------------------------------------------
// Example code
//-----------------------------------------------------------------------------
var ndon='1,,READ,,1,;\n2,,LOAD,,1,;\n3,,JGTZ,,dod,;\n4,,WRITE,=,0,;\n5,,JUMP,,koniecjesli,;\n6,dod,LOAD,,1,;\n7,,STORE,,2,;\n8,,LOAD,,1,;\n9,,SUB,=,1,;\n10,,STORE,,3,;\n11,dopoki,LOAD,,3,;\n12,,JGTZ,,kontyn,;\n13,,JUMP,,koniecdopoki,;\n14,kontyn,LOAD,,2,;\n15,,MULT,,1,;\n16,,STORE,,2,;\n17,,LOAD,,3,;\n18,,SUB,=,1,;\n19,,STORE,,3,;\n20,,JUMP,,dopoki,;\n21,koniecdopoki,WRITE,,2,;\n22,koniecjesli,HALT,,,;\n';
var silnia='1,,READ,,1,;\n2,,LOAD,=,1,;\n3,,STORE,,2,;\n4,JESZCZE,LOAD,,1,;\n5,,JZERO,,GOTOWE,;\n6,,MULT,,2,;\n7,,STORE,,2,;\n8,,LOAD,,1,;\n9,,SUB,=,1,;\n10,,STORE,,1,;\n11,,JUMP,,JESZCZE,;\n12,GOTOWE,WRITE,,2,;\n13,,HALT,,,;';
var suma='1,CZYTAJ,READ,,1,wczytaj kolejną wartość z taśmy;\n2,,LOAD,,1,;\n3,,JZERO,,KONIEC,jeśli wartość = 0 zakończ sumowanie;\n4,,ADD,,2,dodaj dotychczasową sumę do wartości;\n5,,STORE,,2,zapisz nową sumę;\n6,,JUMP,,CZYTAJ,;\n7,KONIEC,WRITE,,2,wypisz sumę;\n8,,HALT,,,;';

// @brief Functions runnig right after loading the window
function firstLoad()
{
	refresh_register();
	order_counter();
}


/*@brief Add new instruction to table, if function don't have parameters 
 * it means the function must create new instruction - empty instructions
 *@param x A value that points to an existing instruction 
 */
function add(x)
{
	display_status();
	var number;
	// Check if instruction is correct
	if(x == undefined)
	{
		x = instruction_counter;
		number = '';	// Add new instructions to arrays - on the end of table
	}
	else
		number = x;		// Add new instructions to arrays - between arrays values

	var label = document.getElementById("label" + number).value;
	var command = document.getElementById("command" + number).value;
	var operand = document.getElementById("operand" + number).value;
	var address = document.getElementById("address" + number).value;
	var comment = document.getElementById("comment" + number).value;

	///// TEST //////
	//console.log(check_label(label));
	//console.log(check_instruction(command, operand));
	//console.log(check_operand(operand, address));
	//console.log(check_address(address, command) );  

	if(check_label(label) == true && check_instruction(command, operand) == true 
		&& check_operand(operand, address) == true && check_address(address, command) == true)
	{
		labels.splice(x,0,label);
		commands.splice(x,0,command);
		operands.splice(x,0,operand);
		addresses.splice(x,0,address);
		comments.splice(x,0,comment);
		document.getElementById("label").value='';
		document.getElementById("address").value='';
		document.getElementById("comment").value='';
	}
	else
	{
		display_status("Błędna instrukcja");
		return;
	}
	instruction_counter++;
	order_counter();
	reload_table();
}

// @brief Function delete row elements from array and reload
// @param x index of row to point elements in array which must be removed
function delete_row(x)
{
	if(instruction_counter>0)
	{
		labels.splice(x,1);
		commands.splice(x,1);
		operands.splice(x,1);
		addresses.splice(x,1);
		comments.splice(x,1);
		instruction_counter--;
		reload_table();
	}
}

// @brief Function edit existing values in the instruction table
// @param x Number of instruction which we want to change
function edit(x)
{
	display_status();
	// Check if instruction is correct
	if(x == undefined)
	{
		display_status("Błąd kompilatora - Edycja");
		return;
	}

	var label = document.getElementById("label" + x).value;
	var command = document.getElementById("command" + x).value;
	var operand = document.getElementById("operand" + x).value;
	var address = document.getElementById("address" + x).value;
	var comment = document.getElementById("comment" + x).value;

	if(check_label(label) == true && check_instruction(command, operand) == true 
		&& check_operand(operand, address) == true && check_address(address, command) == true)
	{
		labels[x] = label;
		commands[x] = command;
		operands[x] = operand; 
		addresses[x] = address;
		comments[x] = comment;
	}
	else
	{
		display_status("Błąd podczas edycji instrukcji");
		return;
	}
	reload_table();
}

// @brief Function adding first row to the table - description of columns
// @param x Variable to transmit pointer to element 'tbody'
function add_first_row(x)
{
	var first_row = document.createElement('tr');
	first_row.id = "firstrow";
	first_row.innerHTML = document.getElementById("firstrow").innerHTML;
	x.appendChild(first_row);
}

// @brief Function adding last row to the table - row to adding new instruction
// @param x Variable to transmit pointer to element 'tbody'
function add_last_row(x)
{
	var last_row = document.createElement('tr');
	last_row.id = "lastrow";
	last_row.innerHTML = document.getElementById("lastrow").innerHTML;
	x.appendChild(last_row);
}

// @brief Function read all elements form arrays and print content to the window table
function reload_table()
{
	var row = "";
	// Get pointer to element of id intruction_list
	var main_struct = document.getElementById("instruction_list");
	
	// Create table
	var tbl = document.createElement('table');
	tbl.id = "program";

	// Create Tbody
	var tbdy = document.createElement('tbody');

	// Create first row - description of columns
	add_first_row(tbdy);

	// Reload all values 
	for (var i=0;i<instruction_counter;i++) 
	{
		row = "";
		var tr = document.createElement('tr');
		if(actual_instruction==i)	
			tr.style.backgroundColor = "#9effaf";
		
		row+='<td><div class="round"><input type="checkbox" id="checkbox'+(i+1)+'" /><label for="checkbox'+(i+1)+'"></label></div></td>';
		row+='<td>'+(i+1)+'</td>';
		row+='<td>'+labels[i]+'</td>';
		row+='<td>'+commands[i]+'</td>';
		row+='<td colspan="2">'+operands[i]+addresses[i]+'</td>';
		row+='<td>'+comments[i]+'</td>';
		row+='<td><button class="plus" onclick="add_row('+i+')">+</button><button class="minus" onclick="delete_row('+i+')">-</button><button onclick="edit_row('+i+')">Edytuj</button></td>';	
		tr.innerHTML = row;
		tbdy.appendChild(tr);
	}

	// Create last row - row to adding new instruction
	add_last_row(tbdy);

	// Delete content of element by id "instruction_list"
	main_struct.innerHTML = '';

	// Append all elements to HTML body
	tbl.appendChild(tbdy);
	main_struct.appendChild(tbl);
}

// @brief Function add row between existing rows 
// @param x Variable point instruction after which a new row is to be entered  
function add_row(x)
{
	var row = "";
	var tr;
	var tr_add;

	// Get pointer to element of id intruction_list
	var main_struct = document.getElementById("instruction_list");
	
	// Create table
	var tbl = document.createElement('table');
	tbl.id = "program";

	// Create Tbody
	var tbdy = document.createElement('tbody');

	// Create first row - description of columns
	add_first_row(tbdy);

	// Values reload but only smaller than argument x
	for(var i=0;i<instruction_counter;i++)
	{
		row = "";
		tr = document.createElement('tr');

		row+='<td><div class="round"><input type="checkbox" id="checkbox'+(i+1)+'" /><label for="checkbox'+(i+1)+'"></label></div></td>';
		row+='<td>'+(i+1)+'</td>';
		row+='<td>'+labels[i]+'</td>';
		row+='<td>'+commands[i]+'</td>';
		row+='<td colspan="2">'+operands[i]+addresses[i]+'</td>';
		row+='<td>'+comments[i]+'</td>';
		row+='<td><button class="plus" onclick="add_row('+i+')">+</button><button class="minus" onclick="delete_row('+i+')">-</button><button onclick="edit_row('+i+')">Edytuj</button></td>';
		tr.innerHTML = row;
		tbdy.appendChild(tr);

		if(x == i)
		{
			row = "";
			tr_add = document.createElement('tr');

			row+='<td><div class="round"><input type="checkbox" id="checkbox'+(i+2)+'" /><label for="checkbox'+(i+1)+'"></label></div></td>';
			row+='<td>'+(x+2)+'</td>';
			row+='<td><input id="label'+(x+1)+'" name="label'+(x+1)+'"></td>';
			row+='<td><select id="command'+(x+1)+'" name="command"><option value="LOAD">LOAD</option><option value="STORE">STORE</option><option value="ADD">ADD</option><option value="SUB">SUB</option><option value="MULT">MULT</option><option value="DIV">DIV</option><option value="READ">READ</option><option value="WRITE">WRITE</option><option value="JUMP">JUMP</option><option value="JZERO">JZERO</option><option value="JGTZ">JGTZ</option><option value="HALT">HALT</option></select></td>';
			row+='<td><select id="operand'+(x+1)+'" name="operand"><option value=""></option><option value="=">=</option><option value="*">*</option></select></td>';
			row+='<td><input id="address'+(x+1)+'" onchange="add('+(x+1)+')"></td>';
			row+='<td><input id="comment'+(x+1)+'"></td>';
			row+='<td><button id="add'+(x+1)+'" onclick="add('+(x+1)+')">OK</button><button onclick="reload_table()">Anuluj</button></td>';
			tr_add.innerHTML = row;
			tbdy.appendChild(tr_add);
		}
	}

	// Create last row - row to adding new instruction
	add_last_row(tbdy);

	// Delete content of element by id "instruction_list"
	main_struct.innerHTML = '';

	// Append all elements to HTML body
	tbl.appendChild(tbdy);
	main_struct.appendChild(tbl);
}

// @brief Function edit existing row in table
// @param x Variable point instruction which we want to edit
function edit_row(x)
{
	var row = "";
	var tr;
	var tr_add;

	// Get pointer to element of id intruction_list
	var main_struct = document.getElementById("instruction_list");
	
	// Create table
	var tbl = document.createElement('table');
	tbl.id = "program";

	// Create Tbody
	var tbdy = document.createElement('tbody');

	// Create first row - description of columns
	add_first_row(tbdy);

	// Values reload but only smaller than argument x
	for(var i=0;i<instruction_counter;i++)
	{
		if(x != i)
		{
			row = "";
			tr = document.createElement('tr');

			row+='<td><div class="round"><input type="checkbox" id="checkbox'+(i+1)+'" /><label for="checkbox'+(i+1)+'"></label></div></td>';
			row+='<td>'+(i+1)+'</td>';
			row+='<td>'+labels[i]+'</td>';
			row+='<td>'+commands[i]+'</td>';
			row+='<td colspan="2">'+operands[i]+addresses[i]+'</td>';
			row+='<td>'+comments[i]+'</td>';
			row+='<td><button class="plus" onclick="add_row('+i+')">+</button><button class="minus" onclick="delete_row('+i+')">-</button><button onclick="edit_row('+i+')">Edytuj</button></td>';
			tr.innerHTML = row;
			tbdy.appendChild(tr);
		}
		else
		{
			row = "";
			tr_add = document.createElement('tr');

			row+='<td><div class="round"><input type="checkbox" id="checkbox'+(i+1)+'" /><label for="checkbox'+(i+1)+'"></label></div></td>';
			row+='<td>'+(x+1)+'</td>';
			row+='<td><input id="label'+x+'" name="label'+x+'" value="'+labels[x]+'"></td>';
			row+='<td><select id="command'+x+'" name="command"><option value="LOAD">LOAD</option><option value="STORE">STORE</option><option value="ADD">ADD</option><option value="SUB">SUB</option><option value="MULT">MULT</option><option value="DIV">DIV</option><option value="READ">READ</option><option value="WRITE">WRITE</option><option value="JUMP">JUMP</option><option value="JZERO">JZERO</option><option value="JGTZ">JGTZ</option><option value="HALT">HALT</option></select></td>';
			row+='<td><select id="operand'+x+'" name="operand"><option value=""></option><option value="=">=</option><option value="*">*</option></select></td>';
			row+='<td><input id="address'+x+'" onchange="edit('+x+')" value="'+addresses[x]+'"></td>';
			row+='<td><input id="comment'+x+'"  value="'+comments[x]+'"></td>';
			row+='<td><button id="add'+x+'" onclick="edit('+x+')">OK</button><button onclick="reload_table()">Anuluj</button></td>';

			tr_add.innerHTML = row;
			tbdy.appendChild(tr_add);
		}
	}

	// Create last row - row to adding new instruction
	add_last_row(tbdy);

	// Delete content of element by id "instruction_list"
	main_struct.innerHTML = '';

	// Append all elements to HTML body
	tbl.appendChild(tbdy);
	main_struct.appendChild(tbl);

	// Select last value set before click button edit
	document.getElementById("command"+x).options[change_command_to_nr(commands[x])].selected=true;
	document.getElementById("operand"+x).options[change_operand_to_nr(operands[x])].selected=true;
}
	

// Function changed text command to the number
function change_command_to_nr(x)
{
	switch(x)
	{
	case 'LOAD':return 0;
	case 'STORE':return 1;
	case 'ADD':return 2;
	case 'SUB':return 3;
	case 'MULT':return 4;
	case 'DIV':return 5;
	case 'READ':return 6;
	case 'WRITE':return 7;
	case 'JUMP':return 8;
	case 'JZERO':return 9;
	case 'JGTZ':return 10;
	case 'HALT':return 11;
	default: return 2;
	}
}
// Function changed text operandum to the number
function change_operand_to_nr(x)
{
	switch(x)
	{
	case '':return 0;
	case '=':return 1;
	case '*':return 2;
	default: return 0;
	}
}

// @brief Main Function to starting the program execution
// @param x Variable is using to check how the program 
//			is to be executed('run' - follow the instruction until the HALT command is given,
//			'step_into' - step by step,
// 			'breakpoint' - follow the instruction until the breakpoint occurs) 
function run(x)
{
	if(iterations_counter==0)
	{
		actual_instruction=0;				// counter of runed instructions
		input_head=0;    	// set "głowica wejsciowa" in first cells input tape
		display_status(); 	// deleted all information from status window
		delete_output(); 	// deleted all values from tape out
		delete_register();  // deleted all values from register
		check_jump_addresses();
	}
	if(x == 'run')
	{
		while(!program())
		{
			iterations_counter++;
			actual_instruction++;
			if(get_higest_value_register() == 0) break;
			if(iterations_counter > Max_iterrarions)
			{
				display_status("Przekroczono czas działania programu");
				refresh_register();
				order_counter();
				break;
			}
		}
		display_status('Koniec programu');
		run_order_counter();
		enable_disable_run("end");
		iterations_counter=0;
	}
	else if(x == 'step_into')
	{
		if(!program())
		{
			iterations_counter++;
			actual_instruction++;
			if(get_higest_value_register() == 0) 
			{
				enable_disable_run("end");
				display_status('Koniec programu');
				run_order_counter();
			}
		}
		else
		{
			enable_disable_run("end");
			display_status('Koniec programu');
			run_order_counter();
			iterations_counter=0;
		}
	}
	else if(x == 'breakpoint')
	{
		read_all_breakpoints();
		while(!program())
		{
			iterations_counter++;
			actual_instruction++;
			if(get_higest_value_register() == 0) break;

			if(check_breakpoint(actual_instruction + 1))
			{
				display_status('Program wstrzymano na instrukcji nr: ' + (actual_instruction + 1));
				enable_disable_run("off");
				break;
			}
		}
		if(commands[actual_instruction] == "HALT")
		{
			set_all_breakpoints();
			display_status('Koniec programu');
			run_order_counter();
			enable_disable_run("end");
			iterations_counter = 0;
		}
	}
	refresh_register();
	order_counter();
	reload_table();
	set_all_breakpoints(); // using only to breakpoints
	// Calculate cost
	time_cost();
	space_cost();
	logarithm_time_cost();
	logarithm_space_cost();
}

// @brief Function reset all values from registers, tape, ...
function reset()
{
	enable_disable_run();
	iterations_counter=0;
	actual_instruction=0;
	command_list = [0,0,0,0,0,0,0,0,0,0,0,0];
	logaritm_time_cost = 0;
	high_val_reg = 0;
	tab_value_max = [];
	delete_register();
	refresh_register();
	order_counter();
	display_status();
	delete_output();
	reload_table();
}

//-----------------------------------------------------------------------------
// Register
//-----------------------------------------------------------------------------

// @brief Function read (or create and read) values from register
// @param x index of rewgister cell
function get_register(x)
{
	if(registers[x]==undefined)
	{	
		registers[x]=0;
		return registers[x];
	}
	else
		return registers[x];
}

// @brief Function reload table in main window
function refresh_register()
{
	var zawartosc="<table>";
	for(var i=0;i<registers.length;i++)
	{
		if(isNaN(registers[i]))
		{
			registers[i]=0;
		}
		zawartosc += '<tr><td>Rejestr ' + i + ':</td><td>' + registers[i] + "</td></tr>";
	}
	zawartosc+="</table>";
	document.getElementById("register").innerHTML = zawartosc;
}

// @brief Function delete all registers from memory and reload table
function delete_register()
{
	registers = [0];
	refresh_register(); 
}
//-----------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
// Control save/read program to/from files
///////////////////////////////////////////////////////////////////////////////
//< Read text from file
function load_file(){
	var myFile = document.getElementById("myFile").files[0];
	// Delete desciption of the begining file (nr, etykieta, adres itp.)
	if(myFile != undefined)
	{
		document.getElementById("print_info").innerHTML = "";
		var file_name = myFile.name.split(".");
		if(file_name[1] == "txt" || file_name[1] == "csv")
		{
			document.getElementById("print_info").innerHTML= "";
			var fileReader = new FileReader();
			fileReader.onload = function(fileLoadedEvent){
				var textFromFileLoaded = fileLoadedEvent.target.result;
				if(textFromFileLoaded.includes(";") == true && textFromFileLoaded.includes("nr,etykieta,komenda,operand,adres,komentarz;\n") == true)
				{
					document.getElementById("print_info").innerHTML = "";
					textFromFileLoaded = textFromFileLoaded.slice(45, );
					load_instruction(textFromFileLoaded);
					read_code(0);	
				}
				else
				{
					document.getElementById("print_info").innerHTML = "Nie odnaleziono średnika lub opisu kolumn (nr,etykieta,...) !";
				}
			};
			fileReader.readAsText(myFile, "UTF-8");
		}
		else	
			document.getElementById("print_info").innerHTML= "Nie znany format pliku !";
	}
	else
		document.getElementById("print_info").innerHTML = "Nie wybrano pliku !"
}
//< Function using to save instruction write in RAM language in the csv or txt file 
function write_to_csv()
{
	var file_name = document.getElementById("save_file_name").value;
	var extension = document.getElementById("extension").value;
	if (file_name.length > 0)
	{
		content = "nr,etykieta,komenda,operand,adres,komentarz;\n";
		for(var i=0;i<instruction_counter;i++)
		{
			content += (i+1) + ',' + labels[i] + ',' + commands[i] + ',' + operands[i] + ',' + addresses[i] + ',' + comments[i] + ';\n';
		}
		uriContent = "data:application/octet-stream," + encodeURIComponent(content);
		document.getElementById("dlink").innerHTML = "<a href=" + uriContent + " download=\""+ file_name +"."+ extension +"\">Pobierz " + file_name + "." + extension + "</a>";
	}
	else
	{alert("Nie podano nazwy pliku.\nWpisz nazwę i naciśnij \"Wygeneruj plik\"")} 

}
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Control input/output tape
///////////////////////////////////////////////////////////////////////////////

//< Function check if the values is introduced to the input tape
 function functionClick(input_num)
 {
	value = document.getElementById("in_" + input_num).value;

	if(!isNaN(value) && input_num <= 6 && value.length > 0)
	{
		we_cell_memory[min_value_in + input_num - 2] = value;
		for(var i = input_num; i < 6;i++)
		{
			// Enable the next cell from the right that is adjacent to the cell
			// in which the value has been entered
			if (document.getElementById("in_"+(input_num + 1)).disabled != false )
				document.getElementById("in_"+(input_num + 1)).disabled = false;

			// If which value is empty disable the rest of the cells to the right side 
			if(document.getElementById("in_" + i).value != (null || undefined ||''))
			{
				document.getElementById("in_"+(i)).disabled = false;
				document.getElementById("in_"+(i + 1)).disabled = false;
			}
		}
		//if (input_num < 6)
		//	document.getElementById("in_"+(input_num + 1)).disabled = false;
		if (input_size < we_cell_memory.length)
			input_size ++;
	}else
	{
		document.getElementById("in_" + input_num).value = "";
		if(input_num < 6)
			for(var i = input_num; i < 6; i++)
				document.getElementById("in_"+(i + 1)).disabled = true;
				//document.getElementById("in_"+(input_num + 1)).disabled = true;
		we_cell_memory[min_value_in + input_num - 2] = null;//0;
		input_size --;
	}
	document.getElementById("length_tape_in").innerHTML = "Długość taśmy wejściowej: <b>" + input_size + "</b>"; //wypisanie długosci tasmy wejsciowej
 }


//< Move the input tape to the left
function Input_move_left()
{
	if (min_value_in == 1)
		return;
	Get_val_tape_in(min_value_in);
	max_value_in--;
	min_value_in--;
	Reload_num_tape_in(min_value_in);
	var flag122 = 0;	
	// Change value in input array
	for(var i=0;i<6;i++)
	{
		var input= document.getElementById("in_"+(i+1));
		input.value = we_cell_memory[min_value_in + i -1];
		
	}
	reload_cells();
	// Case when first move tape in right and next to left
	// and we nothing write to the first input
	if(min_value_in == 1 && we_cell_memory[0] == 0)	
		document.getElementById("in_1").disabled = false;  
}

//< Function disabled/enabled cell in input tape
function reload_cells()
{
	for(var i = 0; i < we_cell_memory.length;i++)
	{
		if(we_cell_memory[i] == null || 
			we_cell_memory[i] == undefined ||
			we_cell_memory[i] == '')
		{
			if(min_value_in > (i+1))
			{
				for(var j = 1; j <= 6; j++)
					document.getElementById("in_"+ j).disabled = true;
				//console.log("przypadek 1");
			}
			else if(min_value_in <= (i+1))
			{
				// Reset all cell - enable all cells
				for(var j = 1; j <= 6; j++)
					document.getElementById("in_"+ j).disabled = false;
				// Set Disabled cell option
				for(var j = (i+3) - min_value_in; j <= 6; j++)
				{
					document.getElementById("in_"+ j).disabled = true;
				}
					//console.log("przypadek 3");
			}
			break;
		}
		if(min_value_in <= (i+1) && (min_value_in + (i+1)) <= 6)
		{
			//console.log("przypadek 4");
			document.getElementById("in_"+((i+2)-min_value_in)).disabled = false;
			document.getElementById("in_"+((i+3)-min_value_in)).disabled = false;
		}
	}
}
//< Reload number above the input cells
function Reload_num_tape_in(New_min)
{
	for(var i=0;i<6;i++)
	{
		number = document.querySelector("#num_wej_"+(i+1));
		number.textContent = New_min+i;
	}
}
//< Reload input cells of the input tape
function Get_val_tape_in(New_min)
{
	for(var i=0;i<6;i++)
	{
		// minus 1 because array is starting to 0 and New min is always bigger than 0
		if(document.getElementById("in_"+(i+1)).value == "") 
			we_cell_memory[New_min + i -1] = null;
		else
			we_cell_memory[New_min + i -1] = document.getElementById("in_"+(i+1)).value;
	}
}

//< Reload input cells of the output tape
function Get_val_tape_out(New_min)
{
	for(var i=0;i<6;i++)
	{
		wy_cell_memory[New_min+i] = document.getElementById("out_"+(i+1)).value;
	}
}	
//< Reload number above the output cells
function Reload_num_tape_out(New_min)
{
	for(var i=0;i<6;i++)
	{
		number = document.querySelector("#num_wyj_"+(i+1));
		number.textContent = New_min+i;
	}
}	

//< Move tape in to the right
function Input_move_right()
{
	Get_val_tape_in(min_value_in);
	if((we_cell_memory.length) <= max_value_in)
	{
		we_cell_memory.push(null);
		max_value_in++;
		min_value_in++;
	}
	else
	{
		max_value_in++;
		min_value_in++;
		
	}
	Reload_num_tape_in(min_value_in);
	var flag122 = 0;	
	// Reload value in tape in
	for(var i=0;i<6;i++)
	{
		var input = document.getElementById("in_"+(i+1));
		input.value = we_cell_memory[min_value_in + i - 1];
		
	}
	reload_cells();
}

//< Move tape out to the right
function Output_move_right()
{
	var tab_size = wy_cell_memory.length;
	Get_val_tape_out(min_value_out);
	if((wy_cell_memory.length-1) <= max_value_out)
	{
		wy_cell_memory.push(null);
		max_value_out++;
		min_value_out++;
	}
	else
	{
		max_value_out++;
		min_value_out++;
	}
	Reload_num_tape_out(min_value_out);
	// Reload output array
	for(var i=0;i<6;i++)
	{
		var output= document.getElementById("out_"+(i+1));
		output.value = wy_cell_memory[min_value_out+i];
		
	}  
}
//< Move tape out to the left
function Output_move_left()
{
	if (min_value_out == 1)
		return;
	Get_val_tape_out(min_value_out);	
	max_value_out--;
	min_value_out--;
	Reload_num_tape_out(min_value_out);
	// Reload value in tabe in
	for(var i=0;i<6;i++)
	{
		var output= document.getElementById("out_"+(i+1));
		output.value = wy_cell_memory[min_value_out+i];
	}  
}

//< Reload output cells of the output tape
function Reload_val_tape_out()
{
	for(var i=0;i<6;i++)
	{
		var output= document.getElementById("out_"+(i+1));
		if(wy_cell_memory[min_value_out + i - 1] != null && wy_cell_memory[min_value_out + i - 1] != "")
			output.value = wy_cell_memory[min_value_out + i - 1];
		else
			output.value = "";
	}
}
///////////////////////////////////////////////////////////////////////////////

// @brief Function display the number of entered orders
function order_counter()
{
	document.getElementById("order_counter").innerHTML = instruction_counter;
}

// @brief Function display the number of entered orders
function run_order_counter()
{
	document.getElementById("run_order_counter").innerHTML = iterations_counter;
}

// @brief Function add and reload value in output tape
function add_output(x)
{
	wy_cell_memory[output_head] = x;
	output_head ++;
	Reload_val_tape_out();
	document.getElementById("length_tape_out").innerHTML = "Długość taśmy wyjściowej: <b>" + output_head + "</b>"; //wypisanie długosci tasmy wyjsciowej
}

// @brief Function delated all values in tyh tape out and reload display tape
function delete_output()
{
	for(var i=max_value_out;i>=6;i--) 
		wy_cell_memory.pop();		//delete redundant outpu cells
	
	for(var i=0;i<6;i++)
		wy_cell_memory[i] = null;	//rest of cells we reset
		output_head = 0;
	Reload_val_tape_out();
	document.getElementById("length_tape_out").innerHTML = "Długość taśmy wyjściowej: <b>" + output_head + "</b>";
}

// @brief Function check if the all of label added to addresses have
//		  connection with instruction in row
function check_jump_addresses()
{
	var flag = false
	for(var i=0;i<instruction_counter;i++)
	{
		if(commands[i]=='JUMP' || commands[i]=='JZERO' || commands[i]=='JGTZ')
		{
			for(var j=0;j<instruction_counter;j++)
			{
				if(addresses[i]==labels[j])
				{
					flag = true;
					break;
				}
			}
			if(flag == false)
				display_status('Brak etykiety '+addresses[i]);
			else
				flag = false;
		}
	}
}

// @brief Function return value of jump address
// @param address Jump label 
function find_jump_address(address)
{
	for(var j=0;j<instruction_counter;j++)
	{
		if(address == labels[j])
		{
			return (j-1);
		}
	}
}
// @brief Function checks which instruction is currently being executed
//		  and performs the appropriate operation (write, read, add, ...)
function program()
{
	switch(commands[actual_instruction]) 
	{
		case 'LOAD':
			command_list[0]++;
			logaritm_time_cost += logarithm_operandum_cost(operands[actual_instruction], addresses[actual_instruction]);
			if(operands[actual_instruction]=='=')
				registers[0] = parseInt(addresses[actual_instruction]);
			else if(operands[actual_instruction]=='')
				registers[0] = parseInt(get_register(addresses[actual_instruction]));
			else
				registers[0] = parseInt(get_register(get_register(addresses[actual_instruction])));
			break;
		case 'STORE':
			command_list[1]++;
			if(operands[actual_instruction]=='')
			{
				registers[addresses[actual_instruction]] = parseInt(registers[0]);
				logaritm_time_cost += (logarithm_cost(registers[0]) + logarithm_cost(addresses[actual_instruction]));
			}
			else
			{
				registers[registers[addresses[actual_instruction]]] = parseInt(registers[0]);
				logaritm_time_cost += (logarithm_cost(registers[0]) + logarithm_cost(addresses[actual_instruction]) + logarithm_cost(registers[addresses[actual_instruction]]));
			}
			break;
		case 'ADD':
			command_list[2]++;
			logaritm_time_cost += (logarithm_operandum_cost(operands[actual_instruction], addresses[actual_instruction]) + logarithm_cost(registers[0]));
			if(operands[actual_instruction]=='=')
				registers[0] = parseInt(registers[0]) + parseInt(addresses[actual_instruction]);
			else if(operands[actual_instruction]=='')
				registers[0] = parseInt(registers[0]) + parseInt(get_register(addresses[actual_instruction]));
			else
				registers[0] = parseInt(registers[0]) + parseInt(get_register(get_register(addresses[actual_instruction])));
			break;
		case 'SUB':
			command_list[3]++;
			logaritm_time_cost += (logarithm_operandum_cost(operands[actual_instruction], addresses[actual_instruction]) + logarithm_cost(registers[0]));
			if(operands[actual_instruction]=='=')
				registers[0] = parseInt(registers[0]) - parseInt(addresses[actual_instruction]);
			else if(operands[actual_instruction]=='')
				registers[0] = parseInt(registers[0]) - parseInt(get_register(addresses[actual_instruction]));
			else
				registers[0] = parseInt(registers[0]) - parseInt(get_register(get_register(addresses[actual_instruction])));
			break;
		case 'MULT':
			command_list[4]++;
			logaritm_time_cost += (logarithm_operandum_cost(operands[actual_instruction], addresses[actual_instruction]) + logarithm_cost(registers[0]));
			if(operands[actual_instruction]=='=')
				registers[0] = parseInt(registers[0]) * parseInt(addresses[actual_instruction]);
			else if(operands[actual_instruction]=='')
				registers[0] = parseInt(registers[0]) * parseInt(get_register(addresses[actual_instruction]));
			else
				registers[0] = parseInt(registers[0]) * parseInt(get_register(get_register(addresses[actual_instruction])));
			break;
		case 'DIV':
			command_list[5]++;
			logaritm_time_cost += (logarithm_operandum_cost(operands[actual_instruction], addresses[actual_instruction]) + logarithm_cost(registers[0]));
			if(operands[actual_instruction]=='=')
				registers[0] = Math.floor(parseInt(registers[0]) / parseInt(addresses[actual_instruction]));
			else if(operands[actual_instruction]=='')
				registers[0] = Math.floor(parseInt(registers[0]) / parseInt(get_register(addresses[actual_instruction])));
			else
				registers[0] = Math.floor(parseInt(registers[0]) / parseInt(get_register(get_register(addresses[actual_instruction]))));
			break;
		case 'READ':
			command_list[6]++;
			if(input_head >= input_size || input_size == 0 || we_cell_memory[input_head] == null || we_cell_memory[input_head] == undefined )
			{
				display_status("Taśma wejścia się skończyła");
				return 3;
			}
			else
			{
				if(operands[actual_instruction]=='')
				{
					logaritm_time_cost += (logarithm_cost(we_cell_memory[input_head]) + logarithm_cost(addresses[actual_instruction]));
					registers[addresses[actual_instruction]] = parseInt(we_cell_memory[input_head]);
					input_head++;
				}
				if(operands[actual_instruction]=='*')
				{
					logaritm_time_cost += (logarithm_cost(we_cell_memory[input_head]) + logarithm_cost(addresses[actual_instruction]) + logarithm_cost(get_register(addresses[actual_instruction])));
					registers[registers[addresses[actual_instruction]]] = parseInt(we_cell_memory[input_head]);
					input_head++;
				}
			}
			break;
		case 'WRITE':
			command_list[7]++;
			logaritm_time_cost += logarithm_operandum_cost(operands[actual_instruction], addresses[actual_instruction]);
			if(operands[actual_instruction]=='=')
				add_output(addresses[actual_instruction]);
			else if(operands[actual_instruction]=='')
				add_output(get_register(addresses[actual_instruction]));
			else
				add_output(get_register(get_register(addresses[actual_instruction])));
			break;
		case 'JUMP':
			command_list[8]++;
			logaritm_time_cost += 1;
			actual_instruction = find_jump_address(addresses[actual_instruction]);
			break;
		case 'JZERO':
			command_list[9]++;
			if(registers[0]==0)
			{
				logaritm_time_cost += logarithm_cost(registers[0]);
				actual_instruction = find_jump_address(addresses[actual_instruction]);
			}
			break;
		case 'JGTZ':
			command_list[10]++;
			if(registers[0]>0)
			{
				logaritm_time_cost += logarithm_cost(registers[0]);
				actual_instruction = find_jump_address(addresses[actual_instruction]);
			}	
			break;
		case 'HALT':
			logaritm_time_cost += 1;
			command_list[11]++;
			return 1;
			break;
		default:
			display_status("Brak komendy Halt");
			return 2;
	}
	return 0;
}
// @brief Functions print information to the screen
function display_status(x)
{	
	if(x==undefined)
		document.getElementById("status").innerHTML ='';
	else
		document.getElementById("status").innerHTML += x + '<br>';
}

// @brief Function print all instruction on the window "save_code"
//		  before save instructions to the file 
function print_code()
{
	var code = "nr,etykieta,komenda,operand,adres,komentarz;\n";
	for(var i=0;i<instruction_counter;i++)
	{
		code+= (i+1) + ',' + labels[i] + ',' + commands[i] + ',' + operands[i] + ',' + addresses[i] + ',' + comments[i] + ';\n';
	}
	document.getElementById("program_code").value=code;
}

function open_help()
{
	window.open("help.pdf");
}

// @brief Function to cut input text and read instruction
function load_instruction(x)
{
	var code;
	var rows;
	var columns;
	if(x==undefined)
		alert("Nie wybrano zawartości");
	else
		code = x;
	display_status();
	if(instruction_counter > 1)
	{
		if(new_program("load") != true)
			return;
	}	
	rows = code.split(";");
	try{
		rows.forEach(function read_columns(Current_value, index, arr)
		{
			columns = Current_value.split(",");
			if(Current_value != undefined && Current_value.length > 1 )
			{
				if(check_all_instruction_dependencies(columns) == true)
				{
					labels[instruction_counter] = columns[1];
					commands[instruction_counter] = columns[2];
					operands[instruction_counter] = columns[3];
					addresses[instruction_counter] = columns[4];
					comments[instruction_counter] = columns[5];
					instruction_counter++;
				}
				else
					throw BreakException;
			}	
		});
	} catch(e)
	{
		if (e !== BreakException) throw e;
		display_status("Wykryto błąd w instrukcji "+(instruction_counter+1));
		display_status("Zawartość nie została wczytana");
	}
	reload_table();
}

function example_code()
{
	var program = document.getElementById("programs").value;

	if(program=='ndon')
		load_instruction(ndon);
	else if(program=='silnia')
		load_instruction(silnia);
	else if(program=='suma')
		load_instruction(suma);

	read_code(0);
}

function save_code(x)
{
	if(x==1)
	{
		document.getElementById("save_code").style.display="inline";
		document.getElementById("content").style.filter="blur(4px)";
		print_code();
	}
	else
	{
		document.getElementById("save_code").style.display="none";
		document.getElementById("content").style.filter="none";
	}
}

function open_chart_cost(x)
{
	if(x==1)
	{
		document.getElementById("chart_cost").style.display="inline";
		document.getElementById("content").style.filter="blur(4px)";
		print_code();
	}
	else
	{
		document.getElementById("chart_cost").style.display="none";
		document.getElementById("content").style.filter="none";
	}
}

function read_code(x)
{
	if(x==1)
	{
		document.getElementById("read_code").style.display="inline";
		document.getElementById("content").style.filter="blur(4px)";
		print_code();
	}
	else
	{
		document.getElementById("read_code").style.display="none";
		document.getElementById("content").style.filter="none";
	}
}

// 
function about(x)
{
	if(x==1)
	{
		document.getElementById("about").style.display="inline";
		document.getElementById("content").style.filter="blur(4px)";
	}
	else
	{
		document.getElementById("about").style.display="none";
		document.getElementById("content").style.filter="none";
	}
}

// @brief Function reload window if user want to create new program !!!
function new_program(x)
{
	if(x == undefined)
	{
		if (confirm("Utworzenie nowego projektu spowoduje utratę danych sesji.\nCzy jesteś pewien, że chcesz kontynuować? ")) {
			location.reload();
		} else {

		}
	}
	else
	{
		if (confirm("Załadowanie projektu spowoduje utratę danych sesji.\nCzy jesteś pewien, że chcesz kontynuować? ")) {
			labels = [];  
			connections = []; 
			commands = [];  
			operands = [];
			addresses = [];
			comments = [];
			instruction_counter = 0; 
			breakpoints = [];
			reset();
			return true
		} else 
			return false;
	}
}

// #brief Function check if instruction have checked option breakpoint !!!
function check_breakpoint(nr_instruction) {
	if (document.getElementById("checkbox"+nr_instruction+"").checked == true)
		return true;
	else
		return false;	
}

// @brief Function enable/ disable buttons to run program
// 		  is using when run program in breakpoint operating mode 
function enable_disable_run(x)
{
	if(x == undefined)
	{
		document.getElementById("run").disabled = false;
		document.getElementById("step").disabled = false;
		document.getElementById("breakpoint").disabled = false;
		document.getElementById("run").style.border = "2px solid #32CD32";
		document.getElementById("step").style.border = "2px solid #32CD32";
		document.getElementById("breakpoint").style.border = "2px solid #32CD32";
	}
	else if(x == "off")
	{
		document.getElementById("run").disabled = true;
		document.getElementById("step").disabled = true;
		document.getElementById("run").style.border = "2px solid #d6d6d6";
		document.getElementById("step").style.border = "2px solid #d6d6d6";
	}
	else
	{
		document.getElementById("run").disabled = true;
		document.getElementById("step").disabled = true;
		document.getElementById("breakpoint").disabled = true;
		document.getElementById("run").style.border = "2px solid #d6d6d6";
		document.getElementById("step").style.border = "2px solid #d6d6d6";
		document.getElementById("breakpoint").style.border = "2px solid #d6d6d6";
	}
}

// @brief Function read all breakpoints
function read_all_breakpoints()
{
	var count = 1;
	while(document.getElementById("checkbox"+count+"") != null)
	{
		breakpoints[count-1] = document.getElementById("checkbox"+count+"").checked;
		count++;
	}
}

// @brief Function set values breakpoints after reload table
function set_all_breakpoints()
{
	var count = 1;
	while(document.getElementById("checkbox"+count+"") != null)
	{
		if(breakpoints[count-1] == true || breakpoints[count-1] == false)
			document.getElementById("checkbox"+count+"").checked = breakpoints[count-1];
		else
			document.getElementById("checkbox"+count+"").checked = false;
		count++;
	}
}

///////////////////////////////////////////////////////////////////////////////
// Function checking all information added by the user
///////////////////////////////////////////////////////////////////////////////

// @brief Function check all possible dependencies
function check_all_instruction_dependencies(elements)
{
	if(elements.length < 6)
		return false;
	var number = elements[0];	
	var label = elements[1];
	var command = elements[2];
	var operand = elements[3];
	var address = elements[4];
	var comment = elements[5];
	if(check_number(number) == true && check_label(label) == true && check_operand(operand, address) == true && check_instruction(command,operand) == true && check_address(address, command) == true)
		return true;
	else
		return false;
}


// @brief Function check instruction in Ram code 
function check_number(x)
{
	if(x != undefined && x != '')
	{
		if(x == (instruction_counter+1))
			return true;
		else
		{
			display_status("Błędny numer instrukcji");
			return false;
		}
	}
}

// @brief Function check instruction in Ram code
// @param x command
// @param y operand 
function check_instruction(x,y)
{
	if(x != undefined && x != '')
	{
		if(x == "LOAD" || x=="STORE" || x=="ADD" || x=="SUB" || x=="MULT" || x=="DIV" || x=="READ" || x=="WRITE" || x=="JUMP" || x=="JZERO" || x=="JGTZ" || x=="HALT")
		{
			if(x == 'STORE' || x == 'READ')
			{
				if(y == '' || y== '*')
					return true;
				else
				{
					display_status("Dla komendy "+x+" nie można użyć operandu "+y+"")
					return false;
				}
			}
			else if(x == 'JUMP' || x == 'JGTZ' || x == 'JZERO' || x == 'HALT')
				{
					if(y == '' || y ==undefined)
						return true;
					else
					{
						display_status("Dla komendy "+x+" nie można użyc operandu "+y+"")
						return false;
					}
				}
			else
				return true;
		}
		else
		{
			display_status("Wykryto błędną instrukcje");
			return false;	
		}
	}
}

// @brief Function check if labels name is correct
function check_label(x)
{
	// checking if first sign no started at the number
	if(x != undefined && x != '')
	{
		var first = x.slice(0,1);
		if(isNaN(first) == false)
		{
			display_status("Etykieta "+ x +" nie może rozpoczynać sie od cyfry");
			return false;
		}
		// Checking if labels name is no repeate in other instruction	
		else
		{
			for(var i = 0;i< actual_instruction; i++)
			{
				if(labels[actual_instruction] == x)
				{
					display_status("Etykieta '"+ x +"' została już użyta");
					return false;
				}
			}
		}
	}
	return true;			
}

// @brief Function check instruction in Ram code
// @param x operand
// @param y address value
function check_operand(x, y)
{
	if(x == undefined) x = '';

	if(y != undefined && x == "=")
	{
		if(y >= 0)
			return true;
		else{ display_status("Adres rejestru musi byc liczba dodatnią"); return false;}
	}
	
	
	if(x == '' || x == '*' || x == '=')
		return true;
	else
	{
		display_status("Błędny operand "+ x);
		return false;
	}

}

// @brief Function check instruction in Ram code
// @param x address
// @param y instruction 
function check_address(x,y)
{
	if(isNaN(x) == false) // if valuse is number
	{
		if(!(y == "JUMP" || y == "JZERO" || y == "JGTZ" ))
			return true;
		else
		{
			display_status("Adres "+ x +" musi być etykietą w przypadku wybrania instrukcji JUMP, JZERO lub JGTZ");
			return false;
		}		
	}
	else if(isNaN(x) == true && (y=="JUMP" || y=="JZERO" || y=="JGTZ" ))  //if value is no number check if value using to jump instructions
	{
		var first = x.slice(0,1);
		if(isNaN(first) == false)
		{
			display_status("Etykieta '"+ x +"' nie może rozpoczynać sie od cyfry");
			return false;
		}
		else
			return true;
	}
	else if(isNaN(x) == true && !(y=="JUMP" || y=="JZERO" || y=="JGTZ" )) // if value is no number and is not a jump instruction
	{
		display_status("Dla instrukcji '"+y+"' nie można użyć etykiety");
		return false;
	}
	else if (x != '' && y == "HALT")									// HALT instruction cannot contain address
	{
		display_status("Instrukcja HALT nie może zawierać adresu");
		return false;
	}		
	else																// another cases
	{
		display_status("Nie mozna poprawnie odczytać adresu instrukcji nr "+(instruction_counter+1));
		return false;
	}
}

// @brief Check comments
function check_comment(x)
{
	///  Unnecessery	
}

///////////////////////////////////////////////////////////////////////////////
// Functions to calculate complexity of algoritms
///////////////////////////////////////////////////////////////////////////////

// @brief Function displays the value of time cost for the adopted uniform
//		  weighting criterion
function time_cost()
{
	var cost = 0;
	for(i=0; i<=11; i++)
	{
		cost += command_list[i];
	}
	document.getElementById("cost_time").innerHTML = cost;
}

// @brief Function displays the value of memory cost for the adopted uniform
//		  weighting criterion
function space_cost()
{
	document.getElementById("cost_memory").innerHTML = registers.length;
}

// @brief Function displays the value of time cost for the assumed
//		  logarithmic criterion

function logarithm_time_cost()
{
	document.getElementById("cost_time_log").innerHTML = Math.round(logaritm_time_cost);
}

// @brief Function displays the value of memory cost for the assumed
//		  logarithmic criterion
function logarithm_space_cost()
{
	document.getElementById("cost_memory_log").innerHTML = Math.round(high_val_reg);
}

// @brief Functions display aor hide information about count
//        of occurrences of individual instructons
// @param x params check if the window content should display or hide 
function print_count_command(x)
{
	if(x==undefined)
		document.getElementById("command_list").innerHTML = '<button onclick = "print_count_command(1)"><img src="images/chevron-down-outline.svg" width="10" height="10" alt=""></button>';
	else
	{
		var list ='';
		list += "LOAD: " + command_list[0]+"<br>";
		list += "STORE: " + command_list[1]+"<br>";
		list += "ADD: " + command_list[2]+"<br>";
		list += "SUB: " + command_list[3]+"<br>";
		list += "MULT: " + command_list[4]+"<br>";
		list += "DIV: " + command_list[5]+"<br>";
		list += "READ: " + command_list[6]+"<br>";
		list += "WRITE: " + command_list[7]+"<br>";
		list += "JUMP: " + command_list[8]+"<br>";
		list += "JZERO: " + command_list[9]+"<br>";
		list += "JGTZ: " + command_list[10]+"<br>";
		list += '<button onclick = "print_count_command()"><img src="images/chevron-up-outline.svg" width="10" height="10" alt=""></button>';
		document.getElementById("command_list").innerHTML = list;
	}
}

// @ brief Function calculate cost operation depending on the opernad
// @param operand is kind of operand
// @param value is number of counted logarithm values
function logarithm_operandum_cost(operand, value, which_register)
{
	if(operand == "=")
		return logarithm_cost(value);
	else if(operand == "")
		if(which_register == "calc_cost")
			return logarithm_cost(value) + logarithm_cost(calc_cost_registers[value]);
		else
			return logarithm_cost(value) + logarithm_cost(registers[value]);	
	else if(operand == "*")
		if(which_register == "calc_cost")
			return logarithm_cost(value) + logarithm_cost(calc_cost_registers[value]) + logarithm_cost(calc_cost_registers[calc_cost_registers[value]]);
		else
			return logarithm_cost(value) + logarithm_cost(registers[value]) + logarithm_cost(registers[registers[value]]);
	else
		display_status("Nie rozpoznany operand: " + opernad);
}

// @ brief Function calculate logaritm
// @param x is the value fed to the logarithm function
function logarithm_cost(x)
{
	
	if(x == undefined)
	{
		return 0;
	}
	else if (x == 0)
		return 1;
	else
		return Math.abs(Math.log2(Math.abs(x))) + 1;
}

// @brief Function search the biggest value in all register
//   during all interrarions of program
function get_higest_value_register()
{
	var high_val_reg_new = 0;
	for(var i=0; i < registers.length;i++)
	{
		if(isNaN(registers[i]) || registers[i] == Infinity)
		{
			display_status("Nieprawidłowa wartość w rejestrze o indeksie: " + i);
			return 0;
		}

		if(tab_value_max[i] < registers[i] && tab_value_max[i] != undefined )
			tab_value_max[i] = registers[i];
		else if(tab_value_max[i] == undefined)
			tab_value_max.push(registers[i]);
	}
	
	for(var j=0; j < tab_value_max.length;j++)
		high_val_reg_new += Math.log2(Math.abs(tab_value_max[j]));

	if(high_val_reg_new > high_val_reg)
		high_val_reg = high_val_reg_new;
}

//-----------------------------------------------------------------------------
// Chart
//-----------------------------------------------------------------------------

// @brief Function Load/reolad chart on the window
function chart() 
{

	var script = document.createElement('script');
	var main_struct = document.getElementById("chart");
	var canvas = document.createElement('canvas');
	canvas.id = "chart_init";
	canvas.className = "chartjs-render-monitor";
	canvas.width =  200;
	canvas.height = 200;

	var chart = "";
	chart += "$(document).ready( function() {";
	chart += 'var chart_init = document.getElementById("chart_init").getContext("2d");';
	chart += "var data = { type: 'line',data: {labels: ["+x_axis_label+"],";
	chart += "datasets: [{ label: '"+ calc_cost_title +"',backgroundColor: 'rgb(50, 205, 50)',borderColor: 'rgb(50, 205, 50)',data: [" + chart_cont_cost_data + "],fill: false},";
	chart += "			{label: '" + function_title +"',backgroundColor: 'rgb(0, 0, 255)',borderColor: 'rgb(0, 0, 255)',data: [" + function_value +"],fill: false}";
	chart += ']}, options: { title: { display: true,text: "Wykresy"},';
	chart += "scales: {xAxes: [{display: true,scaleLabel: {display: true,labelString: 'Wartość / Ilość'}}],";
	chart += 		  "yAxes: [{display: true,scaleLabel: {display: true,labelString: 'Czas / Pamięć'}}]}}};";
	chart += "var chart = new Chart(chart_init, data);})";

	script.innerHTML = chart;
	main_struct.innerHTML = '';
	main_struct.appendChild(canvas);
	main_struct.appendChild(script);

}

// @brief Main function executing the program specified by the user for
//        the various input values. Function called to generate a chart.
function generate_chart_for_cost()
{
	if(get_simulation_values() == false)
		return;
	if (commands.length < 1)
	{
		document.getElementById("chart_error").innerHTML = "Nie wybrano programu !!!";
		return
	}
	else
		document.getElementById("chart_error").innerHTML = "";
	
	// reset array to storage value about calculate cost - using to chart
	all_time_cost = [];
	all_log_time_cost = [];
	all_mem_cost = [];
	all_log_mem_cost = [];
	// For using to executing program for all input values
	for(var k=0; k<generate_numbers.length;k++)
	{
		// Reset values
		if(calc_cost_iterations_counter==0)
		{
			actual_read_input = generate_numbers[k];	// tape in value
			calc_cost_actual_instruction=0;				// counter of runed instructions
			input_head=0;    							// set "głowica wejsciowa" in first cells input tape
			calc_cost_registers = [0];					// Array to storage value of register
			calc_cost_command_list = 0;					// variable using to calculate time cost
			calc_cost_logaritm_time_cost = 0;			// variable using to calculate logaritm time cost
			calc_cost_high_val_reg = 0;					// variable using to calculate memory and logaritm memory cost
			calc_cost_tab_value_max = [];				// array storage max value in register - calc memory cost

		}
		calc_cost_input_size = actual_read_input.length;
		// Executing program for single value or list of values
		while(!calc_cost_program())
		{ 
			calc_cost_iterations_counter++;
			calc_cost_actual_instruction++;

			// Searching the largest value in register
			calc_log_memory_cost();
			if(calc_cost_iterations_counter > Max_iterrarions)
			{
				break;
			}
		}
		// Reset values
		calc_cost_iterations_counter =  0;
		calc_cost_actual_instruction = 0;
		
		// Adding result of calculating cost to the array in order to plot the chart
		all_time_cost.push(calc_cost_command_list);
		all_log_time_cost.push(Math.round(calc_cost_logaritm_time_cost));
		all_mem_cost.push(calc_cost_registers.length); 
		all_log_mem_cost.push(calc_cost_high_val_reg);
	}
	// Check with options user choosed and reload chart
	generate_function();
	generate_cost_time();
	chart();
}

// @brief Function calculate logaritm memory program cost during generating the chart.
//		  Function using auxiliary tregister array to calculate this value - (this array
//		  is using only to generate chart. Array registers[] is using only in normal mode.)
function calc_log_memory_cost()
{
	var high_val_reg_new = 0;
	// Check all cells in register and search max value.
	// If find new regsiter cell add value from register to storage array.
	// If array cells is exist check if the previous value is smaller than the currently read register cells
	for(var i=0; i < calc_cost_registers.length;i++)
	{
		if(calc_cost_tab_value_max[i] < calc_cost_registers[i] && calc_cost_tab_value_max[i] != undefined )
			calc_cost_tab_value_max[i] = (calc_cost_registers[i] == undefined) ? 0 : calc_cost_registers[i]; // if register cell undefined write 0
		else if(calc_cost_tab_value_max[i] == undefined)
			calc_cost_tab_value_max.push((calc_cost_registers[i] == undefined) ? 0 : calc_cost_registers[i]);
	}
	
	// Calculate the logarithm of each of the maximum values ​​of register cells and sum the values
	for(var j=0; j < calc_cost_tab_value_max.length;j++)
	{
		if(calc_cost_tab_value_max[j] != 0)
			high_val_reg_new += Math.log2(Math.abs(calc_cost_tab_value_max[j]));
	}

	if(high_val_reg_new > calc_cost_high_val_reg)
		calc_cost_high_val_reg = high_val_reg_new;
}

// @ brief Function similar to program() but using only to
//	       calculate cost in order to generate chart
function calc_cost_program()
{
	switch(commands[calc_cost_actual_instruction]) 
	{
		case 'LOAD':
			calc_cost_command_list++;
			calc_cost_logaritm_time_cost += logarithm_operandum_cost(operands[calc_cost_actual_instruction], addresses[calc_cost_actual_instruction], "calc_cost");
			if(operands[calc_cost_actual_instruction]=='=')
				calc_cost_registers[0] = parseInt(addresses[calc_cost_actual_instruction]);
			else if(operands[calc_cost_actual_instruction]=='')
				calc_cost_registers[0] = parseInt(calc_cost_get_register(addresses[calc_cost_actual_instruction]));
			else
				calc_cost_registers[0] = parseInt(calc_cost_get_register(calc_cost_get_register(addresses[calc_cost_actual_instruction])));
			break;
		case 'STORE':
			calc_cost_command_list++;
			if(operands[calc_cost_actual_instruction]=='')
			{
				calc_cost_registers[addresses[calc_cost_actual_instruction]] = parseInt(calc_cost_registers[0]);
				calc_cost_logaritm_time_cost += (logarithm_cost(calc_cost_registers[0]) + logarithm_cost(addresses[calc_cost_actual_instruction]));
			}
			else
			{
				calc_cost_registers[calc_cost_registers[addresses[calc_cost_actual_instruction]]] = parseInt(calc_cost_registers[0]);
				calc_cost_logaritm_time_cost += (logarithm_cost(calc_cost_registers[0]) + logarithm_cost(addresses[calc_cost_actual_instruction]) + logarithm_cost(calc_cost_registers[addresses[calc_cost_actual_instruction]]));
			}
			break;
		case 'ADD':
			calc_cost_command_list++;
			calc_cost_logaritm_time_cost += (logarithm_operandum_cost(operands[calc_cost_actual_instruction], addresses[calc_cost_actual_instruction], "calc_cost") + logarithm_cost(calc_cost_registers[0]));
			if(operands[calc_cost_actual_instruction]=='=')
			calc_cost_registers[0] = parseInt(calc_cost_registers[0]) + parseInt(addresses[calc_cost_actual_instruction]);
			else if(operands[calc_cost_actual_instruction]=='')
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) + parseInt(calc_cost_get_register(addresses[calc_cost_actual_instruction]));
			else
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) + parseInt(calc_cost_get_register(calc_cost_get_register(addresses[calc_cost_actual_instruction])));
			break;
		case 'SUB':
			calc_cost_command_list++;
			calc_cost_logaritm_time_cost += (logarithm_operandum_cost(operands[calc_cost_actual_instruction], addresses[calc_cost_actual_instruction], "calc_cost") + logarithm_cost(calc_cost_registers[0]));
			if(operands[calc_cost_actual_instruction]=='=')
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) - parseInt(addresses[calc_cost_actual_instruction]);
			else if(operands[calc_cost_actual_instruction]=='')
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) - parseInt(calc_cost_get_register(addresses[calc_cost_actual_instruction]));
			else
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) - parseInt(calc_cost_get_register(calc_cost_get_register(addresses[calc_cost_actual_instruction])));
			break;
		case 'MULT':
			calc_cost_command_list++;
			calc_cost_logaritm_time_cost += (logarithm_operandum_cost(operands[calc_cost_actual_instruction], addresses[calc_cost_actual_instruction], "calc_cost") + logarithm_cost(calc_cost_registers[0]));
			if(operands[calc_cost_actual_instruction]=='=')
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) * parseInt(addresses[calc_cost_actual_instruction]);
			else if(operands[calc_cost_actual_instruction]=='')
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) * parseInt(calc_cost_get_register(addresses[calc_cost_actual_instruction]));
			else
				calc_cost_registers[0] = parseInt(calc_cost_registers[0]) * parseInt(calc_cost_get_register(calc_cost_get_register(addresses[calc_cost_actual_instruction])));
			break;
		case 'DIV':
			calc_cost_command_list++;
			calc_cost_logaritm_time_cost += (logarithm_operandum_cost(operands[calc_cost_actual_instruction], addresses[calc_cost_actual_instruction], "calc_cost") + logarithm_cost(calc_cost_registers[0]));
			if(operands[calc_cost_actual_instruction]=='=')
				calc_cost_registers[0] = Math.floor(parseInt(calc_cost_registers[0]) / parseInt(addresses[calc_cost_actual_instruction]));
			else if(operands[calc_cost_actual_instruction]=='')
				calc_cost_registers[0] = Math.floor(parseInt(calc_cost_registers[0]) / parseInt(calc_cost_get_register(addresses[calc_cost_actual_instruction])));
			else
				calc_cost_registers[0] = Math.floor(parseInt(calc_cost_registers[0]) / parseInt(calc_cost_get_register(calc_cost_get_register(addresses[calc_cost_actual_instruction]))));
			break;
		case 'READ':
			calc_cost_command_list++;
			if(input_head >= calc_cost_input_size || calc_cost_input_size == 0 || actual_read_input[input_head] == null || actual_read_input[input_head] == undefined )
			{
				
				console.log("actual_read_input"+actual_read_input);
				console.log("input_head"+input_head);
				console.log("calc_cost_input_size "+calc_cost_input_size );
				console.log(" actual_read_input[input_head] "+ actual_read_input[input_head] );
				document.getElementById("chart_error").innerHTML = "Taśma wejściowa się skończyła";
				return 3;
			}
			else
			{
				if(operands[calc_cost_actual_instruction]=='')
				{
					calc_cost_logaritm_time_cost += (logarithm_cost(actual_read_input[input_head ]) + logarithm_cost(addresses[calc_cost_actual_instruction]));
					calc_cost_registers[addresses[calc_cost_actual_instruction]] = parseInt(actual_read_input[input_head ]);
					input_head++;
				}
				if(operands[calc_cost_actual_instruction]=='*')
				{
					calc_cost_logaritm_time_cost += (logarithm_cost(actual_read_input[input_head ]) + logarithm_cost(addresses[calc_cost_actual_instruction]) + logarithm_cost(calc_cost_get_register(addresses[calc_cost_actual_instruction])));
					calc_cost_registers[calc_cost_registers[addresses[calc_cost_actual_instruction]]] = parseInt(actual_read_input[input_head ]);
					input_head++;
				}
			}
			break;
		case 'WRITE':
			calc_cost_command_list++;
			calc_cost_logaritm_time_cost += logarithm_operandum_cost(operands[calc_cost_actual_instruction], addresses[calc_cost_actual_instruction], "calc_cost");
			break;
		case 'JUMP':
			calc_cost_command_list++;
			calc_cost_logaritm_time_cost += 1;
			calc_cost_actual_instruction = find_jump_address(addresses[calc_cost_actual_instruction]);
			break;
		case 'JZERO':
			calc_cost_command_list++;
			if(calc_cost_registers[0]==0)
			{
				calc_cost_logaritm_time_cost += logarithm_cost(calc_cost_registers[0]);
				calc_cost_actual_instruction = find_jump_address(addresses[calc_cost_actual_instruction]);
			}
			break;
		case 'JGTZ':
			calc_cost_command_list++;
			if(calc_cost_registers[0]>0)
			{
				calc_cost_logaritm_time_cost += logarithm_cost(calc_cost_registers[0]);
				calc_cost_actual_instruction = find_jump_address(addresses[calc_cost_actual_instruction]);
			}	
			break;
		case 'HALT':
			calc_cost_logaritm_time_cost += 1;
			calc_cost_command_list++;
			return 1;
			break;
		default:
			return 2;
	}
	return 0;
}

// @brief Function read (or create and read) values from register - using only to calculate cost
// @param x index of register cell
function calc_cost_get_register(x)
{
	if(calc_cost_registers[x] == undefined)
	{	
		calc_cost_registers[x]=0;
		return calc_cost_registers[x];
	}
	else
		return calc_cost_registers[x];
}

// @brief Function check which chart function user has selected
//		  and calcualte values to create that chart
function generate_function()
{
	var multiplier = parseInt(document.getElementById("mult_fun").value);
	var arg_fcn = [];
	function_value = [];
	calc_value = document.getElementById("size_count").value;
	if(calc_value == "Max")
		arg_fcn = generate_numbers.flat();
	else if (calc_value == "Len")
	{
		for(var i=1; i<=generate_numbers.length;i++)
			arg_fcn.push(i);
	}
	// If check length of tape in and decide which feature will be
	// selected: length or operandum size
	else if(calc_value == "User_num")
	{
		var flag = 0;
		var size = generate_numbers[0].length;
		// Check what will be the "Rozmiar zadania"
		for(var i=1; i<generate_numbers.length;i++)
			if(size > generate_numbers[i].length || size < generate_numbers[i].length)
				flag = 1;

		if(flag == 1)
		{
			document.getElementById("chart_error").innerHTML = "Ze względu na różną długość taśmy wejściowej uwzględniono w funkcji O(...) rozmiar taśmy";
			for(var i=0; i<generate_numbers.length;i++)
				arg_fcn.push(generate_numbers[i].length);
		}
		else
		{
			arg_fcn = generate_numbers.flat();
			document.getElementById("chart_error").innerHTML = "Ze względu na tą samą długość taśmy wejściowej uwzględniono w funkcji O(...) rozmiar operandum";	
		}
	}
	var x = document.getElementById("fun").value;
	if(x == "O(1)")
	{
		function_title = "O(1)";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * 1;
	}
	else if(x == "O(x)")
	{
		function_title = "O(x)";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * arg_fcn[i];
	}
	else if(x == "O(x^2)")
	{
		function_title = "O(x^2)";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * Math.pow(arg_fcn[i], 2);
	}
	else if(x == "O(x^3)")
	{
		function_title = "O(x^3)";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * Math.pow(arg_fcn[i], 3);
	}
	else if(x == "O(x^4)")
	{
		function_title = "O(x^4)";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * Math.pow(arg_fcn[i], 4);
	}
	else if(x == "O(log(|x|))")
	{
		function_title = "O(log(|x|))";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * Math.log2( Math.abs(arg_fcn[i]));
	}
	else if(x == "O(xlog(|x|))")
	{
		function_title = "O(xlog(|x|))";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * arg_fcn[i] * Math.log2(Math.abs(arg_fcn[i]));
	}
	else if(x == "O((x^2)*log(|x|))")
	{
		function_title = "O((x^2)*log(|x|))";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = multiplier * Math.pow(arg_fcn[i],2) * Math.log2(Math.abs(arg_fcn[i]));
	}
	else
	{
		function_title = "";
		for(var i=0; i<generate_numbers.length;i++)
			function_value[i] = 0;
	}

	chart();
}

// @brief Function check which complexity the user has selected
//		  and calcualte values to create that chart
function generate_cost_time()
{
	chart_cont_cost_data = [];
	var x = document.getElementById("cost").value;
	if(x == "OFF")
	{
		calc_cost_title = "";
		chart_cont_cost_data = [];
	}
	else if(x == "TIME")
	{
		calc_cost_title = "Złożoność czasowa";
		for(var i=0; i<generate_numbers.length;i++)
		chart_cont_cost_data[i] = all_time_cost[i];
	}
	else if(x == "LOG_TIME")
	{
		calc_cost_title = "Złożonosć logarytmiczna czasowa";
		for(var i=0; i<generate_numbers.length;i++)
		chart_cont_cost_data[i] = all_log_time_cost[i];
	}
	else if(x == "MEMORY")
	{
		calc_cost_title = "Złożoność pamięciowa";
		for(var i=0; i<generate_numbers.length;i++)
		chart_cont_cost_data[i] = all_mem_cost[i];
	}
	else if(x == "LOG_MOMORY")
	{
		calc_cost_title= "Złożoność logarytmiczna pamięciowa";
		for(var i=0; i<generate_numbers.length;i++)
		chart_cont_cost_data[i] = all_log_mem_cost[i];
	}
	else
	{
		calc_cost_title = "";
		chart_cont_cost_data = [];
	}
	chart();
}

// @brief Function display/ hide chart window 
function set_size_or_count()
{
	var x = document.getElementById("size_count").value;
	if(x == "Max")
	{
		document.getElementById("Operandum_size").style.display="block";
		document.getElementById("in_tape_size").style.display="none";
		document.getElementById("user_tape").style.display="none";
	}
	else if(x == "User_num")
	{
		document.getElementById("Operandum_size").style.display="none";
		document.getElementById("in_tape_size").style.display="none";
		document.getElementById("user_tape").style.display="block";
	}
	else
	{
		document.getElementById("Operandum_size").style.display="none";
		document.getElementById("user_tape").style.display="none";
		document.getElementById("in_tape_size").style.display="block";
	}
}

// @brief Function checked which options user selected and generate
//		  input tape using in Ram program
function get_simulation_values()
{
	x_axis_label = []; 
	var x = document.getElementById("size_count").value;
	if(x == "Max")
	{
		var max_value = parseInt(document.getElementById("max_operand_value").value);
		if(isNaN(max_value) != false)
		{
			document.getElementById("chart_error").innerHTML = "Podana wartość nie jest cyfrą";
			return false
		}
		var resolution = parseInt(document.getElementById("resolution").value);
		var step_value = max_value/resolution; 
		var value = 0;

		generate_numbers = [];
		for (var i = 1; i <= resolution; i++)
		{
			value = i * step_value;
			value = Math.round(value);
			if(max_value > value)
				generate_numbers.push([value]);
			else if(i == (resolution - 1))
			{
				generate_numbers.push([max_value]);
				break;
			}
			else
				break;
		}
		x_axis_label = generate_numbers.flat(); 
	}
	else if(x == "User_num")
	{
		generate_numbers = [];
		var tape_in = document.getElementById("user_tape_read").value;
		for(var k = 0; k < tape_in.length; k++)
		{
			if(tape_in.search(" ") == -1)
				break;
			tape_in = tape_in.replace(" ","");
		} 
		if(validate_input_data(tape_in) == false)
			return false;
		var list_tape_in = tape_in.split(";");
		list_tape_in.pop();
		var once_tape_list;
		var new_list = [];
		for(var i = 0; i<list_tape_in.length; i++)
		{
			once_tape_list = [];
			new_list = [];
			x_axis_label.push(("'"+list_tape_in[i]+"'"));
			once_tape_list = list_tape_in[i].slice(1,-1).split(',');
			
			for(var j = 0; j < once_tape_list.length; j++)
			{
				new_list.push(parseInt(once_tape_list[j]));
				
			}
			generate_numbers.push(new_list);
		} 
		
		
	}
	else
	{
		var size_tape_in = parseInt(document.getElementById("size_tape_in").value);
		var kind_of_numbers = document.getElementById("kind_of_numbers").value;
		var list = [];
		var new_list = [];
		generate_numbers = [];

		if(kind_of_numbers == "1")
			list = natural_numbers.slice(0,size_tape_in);
		else if(kind_of_numbers == "2")
			list = prime_numbers.slice(0,size_tape_in);
		else if(list == "3")
			list = composite_numbers.slice(0,size_tape_in);
		else if (kind_of_numbers == "4")
			list = natural_numbers.slice(0,size_tape_in);
		else if (kind_of_numbers == "5")
			list = constant_1.slice(0,size_tape_in);

		for(var j = 1; j<=size_tape_in;j++)
		{
			if(kind_of_numbers == "4" || kind_of_numbers == "5")
			{
				new_list = list.slice(0, j);
				new_list.push(0);
				generate_numbers.push(new_list);
				x_axis_label.push(("'["+new_list+"]'"));
				console.log("New_list: ", new_list);
			}
			else
			{
				generate_numbers.push(list.slice(0, j));
				x_axis_label.push(("'["+list.slice(0, j)+"]'"));
			}

			
			//x_axis_label.push(j+1); 
		}
			
	}
}

// @brief Function check values entered by the user and iform if some values are incorrect
function validate_input_data(x)
{
	var once_tape_list = "";
	count_of_tape = x.match(/;/g);
	if(count_of_tape == null)
	{
		document.getElementById("chart_error").innerHTML = "Brak średnika";
		return false;
	}
	var list_tape_in = x.split(";");
	if(list_tape_in[list_tape_in.length -1] == "")
		list_tape_in.pop();
	if(count_of_tape.length != list_tape_in.length)
	{
		document.getElementById("chart_error").innerHTML = "Liczba danych wejściowych nie pokrywa się z liczba średników";
		return false;
	}
	for(var i =0; i<list_tape_in.length; i++)
	{
		if(list_tape_in[i].slice(0,1) != "[" )
		{
			document.getElementById("chart_error").innerHTML = "Nie odnaleziono klamry początkowej";
			return false;
		}
		if(list_tape_in[i].slice(-1) != "]")
		{
			document.getElementById("chart_error").innerHTML = "Nie odnaleziono klamry końcowej";
			return false
		}
		once_tape_list = list_tape_in[i].slice(1,-1).split(',');
		for(var j =0; j < once_tape_list.length;j++)
		{
			if(isNaN(once_tape_list[j]) != false)
			{
				document.getElementById("chart_error").innerHTML = "Jedna z podanych wartości nie jest cyfrą";
				return false
			}
		}
	}
	return true;
}
